import { a as _objectSpread2$1, b as _extends } from '../chunk-34722740.js';
import { Box as Box$1 } from 'fannypack/Box';
import 'fannypack/Code';
import 'fannypack/Text';
import { ThemeContext } from 'fannypack/styled';
import { createComponent as createComponent$1, createElement as createElement$1, useClassName } from 'fannypack/utils';
import { c as codeTheme, P as Pre, L as Line, T as Token, H as HighlightedCode$1 } from './styles-14489672.js';
import { createContext, useContext, createElement, forwardRef as forwardRef$1, memo as memo$1, useDebugValue } from 'react';
import 'react-dom';
import Highlight, { defaultProps } from 'prism-react-renderer';

var SystemContext = createContext({});

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function isRenderProp(children) {
  return typeof children === "function";
}

var useCreateElement = function useCreateElement(type, props, children) {
  if (children === void 0) {
    children = props.children;
  }

  var context = useContext(SystemContext);

  if (context.useCreateElement) {
    return context.useCreateElement(type, props, children);
  }

  if (isRenderProp(children)) {
    var _ = props.children,
        rest = _objectWithoutPropertiesLoose(props, ["children"]);

    return children(rest);
  }

  return createElement(type, props, children);
};

function splitProps(props, keys) {
  var propsKeys = Object.keys(props);
  var picked = {};
  var omitted = {};

  for (var _i = 0, _propsKeys = propsKeys; _i < _propsKeys.length; _i++) {
    var key = _propsKeys[_i];

    if (keys.indexOf(key) >= 0) {
      picked[key] = props[key];
    } else {
      omitted[key] = props[key];
    }
  }

  return [picked, omitted];
}

function memo(component, propsAreEqual) {
  return memo$1(component, propsAreEqual);
}

function forwardRef(component) {
  return forwardRef$1(component);
}

function createComponent(_ref) {
  var type = _ref.as,
      useHook = _ref.useHook,
      _ref$keys = _ref.keys,
      keys = _ref$keys === void 0 ? useHook && useHook.__keys || [] : _ref$keys,
      _ref$propsAreEqual = _ref.propsAreEqual,
      propsAreEqual = _ref$propsAreEqual === void 0 ? useHook && useHook.__propsAreEqual : _ref$propsAreEqual,
      _ref$useCreateElement = _ref.useCreateElement,
      useCreateElement$1 = _ref$useCreateElement === void 0 ? useCreateElement : _ref$useCreateElement;

  var Comp = function Comp(_ref2, ref) {
    var _ref2$as = _ref2.as,
        as = _ref2$as === void 0 ? type : _ref2$as,
        props = _objectWithoutPropertiesLoose(_ref2, ["as"]);

    if (useHook) {
      var _splitProps = splitProps(props, keys),
          _options = _splitProps[0],
          htmlProps = _splitProps[1];

      var _useHook = useHook(_options, _objectSpread2({
        ref: ref
      }, htmlProps)),
          unstable_wrap = _useHook.unstable_wrap,
          elementProps = _objectWithoutPropertiesLoose(_useHook, ["unstable_wrap"]); // @ts-ignore


      var asKeys = as.render ? as.render.__keys : as.__keys;
      var asOptions = asKeys ? splitProps(props, asKeys)[0] : {};
      var element = useCreateElement$1(as, _objectSpread2({}, elementProps, {}, asOptions));

      if (unstable_wrap) {
        return unstable_wrap(element);
      }

      return element;
    }

    return useCreateElement$1(as, props);
  };

  Comp.__keys = keys;

  if (process.env.NODE_ENV !== "production" && useHook) {
    Comp.displayName = useHook.name.replace(/^(unstable_)?use/, "");
  }

  return memo(forwardRef(Comp), propsAreEqual);
}

function useToken(token, defaultValue) {
  useDebugValue(token);
  var context = useContext(SystemContext);
  return context[token] != null ? context[token] : defaultValue;
}

function useProps(name, options, htmlProps) {
  if (options === void 0) {
    options = {};
  }

  if (htmlProps === void 0) {
    htmlProps = {};
  }

  var hookName = "use" + name + "Props";
  useDebugValue(hookName);
  var useHook = useToken(hookName);

  if (useHook) {
    return useHook(options, htmlProps);
  }

  return htmlProps;
}

function useOptions(name, options, htmlProps) {
  if (options === void 0) {
    options = {};
  }

  if (htmlProps === void 0) {
    htmlProps = {};
  }

  var hookName = "use" + name + "Options";
  useDebugValue(hookName);
  var useHook = useToken(hookName);

  if (useHook) {
    return _objectSpread2({}, options, {}, useHook(options, htmlProps));
  }

  return options;
}

function isObject(arg) {
  return typeof arg === "object" && arg != null;
}

function toArray(arg) {
  if (Array.isArray(arg)) {
    return arg;
  }

  return typeof arg !== "undefined" ? [arg] : [];
}

function deepEqual(objA, objB, depth) {
  if (depth === void 0) {
    depth = 1;
  }

  if (objA === objB) return true;
  if (!objA || !objB) return false;
  var aKeys = Object.keys(objA);
  var bKeys = Object.keys(objB);
  var length = aKeys.length;
  if (bKeys.length !== length) return false;

  for (var _i = 0, _aKeys = aKeys; _i < _aKeys.length; _i++) {
    var key = _aKeys[_i];

    if (objA[key] !== objB[key]) {
      if (!depth || !isObject(objA[key]) || !isObject(objB[key]) || !deepEqual(objA[key], objB[key], depth - 1)) {
        return false;
      }
    }
  }

  return true;
}

function createHook(options) {
  var composedHooks = toArray(options.compose);

  var __useOptions = function __useOptions(hookOptions, htmlProps) {
    // Call the current hook's useOptions first
    if (options.useOptions) {
      hookOptions = options.useOptions(hookOptions, htmlProps);
    } // If there's name, call useOptions from the system context


    if (options.name) {
      hookOptions = useOptions(options.name, hookOptions, htmlProps);
    }

    return hookOptions;
  };

  var useHook = function useHook(hookOptions, htmlProps, unstable_ignoreUseOptions) {
    if (hookOptions === void 0) {
      hookOptions = {};
    }

    if (htmlProps === void 0) {
      htmlProps = {};
    }

    if (unstable_ignoreUseOptions === void 0) {
      unstable_ignoreUseOptions = false;
    }

    // This won't execute when useHook was called from within another useHook
    if (!unstable_ignoreUseOptions) {
      hookOptions = __useOptions(hookOptions, htmlProps);
    } // We're already calling composed useOptions here
    // That's why we ignoreUseOptions for composed hooks


    if (options.compose) {
      composedHooks.forEach(function (hook) {
        hookOptions = hook.__useOptions(hookOptions, htmlProps);
      });
    } // Call the current hook's useProps


    if (options.useProps) {
      htmlProps = options.useProps(hookOptions, htmlProps);
    } // If there's name, call useProps from the system context


    if (options.name) {
      htmlProps = useProps(options.name, hookOptions, htmlProps);
    }

    if (options.compose) {
      if (options.useComposeOptions) {
        hookOptions = options.useComposeOptions(hookOptions, htmlProps);
      }

      composedHooks.forEach(function (hook) {
        // @ts-ignore The third option is only used internally
        htmlProps = hook(hookOptions, htmlProps, true);
      });
    }

    return htmlProps;
  };

  if (process.env.NODE_ENV !== "production" && options.name) {
    Object.defineProperty(useHook, "name", {
      value: "use" + options.name
    });
  }

  useHook.__useOptions = __useOptions; // It's used by createComponent to split option props (keys) and html props

  useHook.__keys = [].concat(composedHooks.reduce(function (allKeys, hook) {
    allKeys.push.apply(allKeys, hook.__keys || []);
    return allKeys;
  }, []), options.useState ? options.useState.__keys : [], options.keys || []);
  var hasPropsAreEqual = Boolean(options.propsAreEqual || composedHooks.find(function (hook) {
    return Boolean(hook.__propsAreEqual);
  }));

  if (hasPropsAreEqual) {
    useHook.__propsAreEqual = function (prev, next) {
      var result = options.propsAreEqual && options.propsAreEqual(prev, next);

      if (result != null) {
        return result;
      }

      for (var _iterator = composedHooks, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
        var _ref;

        if (_isArray) {
          if (_i >= _iterator.length) break;
          _ref = _iterator[_i++];
        } else {
          _i = _iterator.next();
          if (_i.done) break;
          _ref = _i.value;
        }

        var hook = _ref;
        var propsAreEqual = hook.__propsAreEqual;
        var hookResult = propsAreEqual && propsAreEqual(prev, next);

        if (hookResult != null) {
          return hookResult;
        }
      }

      return deepEqual(prev, next);
    };
  }

  return useHook;
}

var useBox = createHook({
  name: "Box",
  keys: ["unstable_system"]
});
var Box = createComponent({
  as: "div",
  useHook: useBox
});

function useProps$1(props) {
  if (props === void 0) {
    props = {};
  }

  var boxProps = Box$1.useProps(props);
  var className = useClassName({
    style: HighlightedCode$1,
    styleProps: props,
    prevClassName: boxProps.className
  });
  return _objectSpread2$1({}, boxProps, {
    className: className
  });
}

var HighlightedCode = createComponent$1(function (props) {
  var theme = useContext(ThemeContext);
  var codeTheme$1 = codeTheme(_objectSpread2$1({
    theme: theme
  }, props));
  var HighlightedCodeProps = useProps$1(props);
  return createElement$1({
    children: createElement(Highlight, _extends({}, defaultProps, {
      code: props.code // @ts-ignore
      ,
      language: props.language,
      theme: codeTheme$1
    }, props.wrapperProps), function (_ref) {
      var className = _ref.className,
          style = _ref.style,
          tokens = _ref.tokens,
          getLineProps = _ref.getLineProps,
          getTokenProps = _ref.getTokenProps;
      return createElement(Pre, _extends({
        isBlock: props.isBlock,
        className: className,
        style: style,
        overrides: props.overrides
      }, props.preProps), tokens.map(function (line, i) {
        return createElement(Line, _extends({
          key: i,
          isBlock: props.isBlock
        }, getLineProps({
          line: line,
          key: i
        }), {
          overrides: props.overrides
        }, props.lineProps), line.map(function (token, key) {
          return createElement(Token, _extends({
            key: key
          }, getTokenProps({
            token: token,
            key: key
          }), {
            overrides: props.overrides
          }, props.tokenProps));
        }));
      }));
    }),
    component: Box,
    htmlProps: HighlightedCodeProps
  });
}, {
  attach: {
    useProps: useProps$1
  },
  defaultProps: {
    code: '',
    language: 'javascript',
    preProps: {},
    lineProps: {},
    tokenProps: {},
    wrapperProps: {}
  },
  themeKey: 'HighlightedCode'
});

export { HighlightedCode };
